package b4a.example;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.collections.Map _aktdest = null;
public static String _secret = "";
public static String _pb = "";
public static String _pbme = "";
public static String _pbdevices = "";
public static String _pbcontacts = "";
public static String _pbsubscriptions = "";
public static String _pbpushes = "";
public static String _pbupload = "";
public static String _pboauth2 = "";
public anywheresoftware.b4a.objects.ListViewWrapper _lv = null;
public anywheresoftware.b4a.samples.httputils2.httputils2service _httputils2service = null;
public b4a.example.push _push = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
vis = vis | (push.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
anywheresoftware.b4a.samples.httputils2.httpjob _job = null;
 //BA.debugLineNum = 80;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 82;BA.debugLine="Activity.LoadLayout(\"Layout1\")";
mostCurrent._activity.LoadLayout("Layout1",mostCurrent.activityBA);
 //BA.debugLineNum = 83;BA.debugLine="Activity.AddMenuItem(\"ME\",\"mnuMe\")";
mostCurrent._activity.AddMenuItem("ME","mnuMe");
 //BA.debugLineNum = 84;BA.debugLine="Activity.AddMenuItem(\"Contacts\",\"mnuContacts\")";
mostCurrent._activity.AddMenuItem("Contacts","mnuContacts");
 //BA.debugLineNum = 85;BA.debugLine="Activity.AddMenuItem(\"Devices\",\"mnuDevices\")";
mostCurrent._activity.AddMenuItem("Devices","mnuDevices");
 //BA.debugLineNum = 86;BA.debugLine="Activity.AddMenuItem(\"Subscriptions\",\"mnuSubscrip";
mostCurrent._activity.AddMenuItem("Subscriptions","mnuSubscriptions");
 //BA.debugLineNum = 87;BA.debugLine="Activity.AddMenuItem(\"Pushes\",\"mnuPushes\")";
mostCurrent._activity.AddMenuItem("Pushes","mnuPushes");
 //BA.debugLineNum = 88;BA.debugLine="Activity.Title = \"Pushbullet TEST\"";
mostCurrent._activity.setTitle((Object)("Pushbullet TEST"));
 //BA.debugLineNum = 89;BA.debugLine="aktdest.Initialize";
_aktdest.Initialize();
 //BA.debugLineNum = 90;BA.debugLine="lv.Clear";
mostCurrent._lv.Clear();
 //BA.debugLineNum = 91;BA.debugLine="lv.TwoLinesLayout.Label.TextColor = Colors.ARGB(2";
mostCurrent._lv.getTwoLinesLayout().Label.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.ARGB((int) (255),(int) (17),(int) (31),(int) (151)));
 //BA.debugLineNum = 92;BA.debugLine="Dim job As HttpJob";
_job = new anywheresoftware.b4a.samples.httputils2.httpjob();
 //BA.debugLineNum = 93;BA.debugLine="job.Initialize(\"ME\",Me)";
_job._initialize(processBA,"ME",main.getObject());
 //BA.debugLineNum = 94;BA.debugLine="job.Download(PBme)";
_job._download(_pbme);
 //BA.debugLineNum = 95;BA.debugLine="job.GetRequest.SetHeader(\"Authorization\", \"Bearer";
_job._getrequest().SetHeader("Authorization","Bearer "+_secret);
 //BA.debugLineNum = 98;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 242;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 243;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 240;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 241;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        anywheresoftware.b4a.samples.httputils2.httputils2service._process_globals();
main._process_globals();
push._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 45;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 48;BA.debugLine="Private lv As ListView";
mostCurrent._lv = new anywheresoftware.b4a.objects.ListViewWrapper();
 //BA.debugLineNum = 49;BA.debugLine="End Sub";
return "";
}
public static String  _jobdone(anywheresoftware.b4a.samples.httputils2.httpjob _job) throws Exception{
anywheresoftware.b4a.objects.collections.JSONParser _parser = null;
anywheresoftware.b4a.objects.collections.Map _root = null;
String _iden = "";
String _email = "";
String _name = "";
double _created = 0;
anywheresoftware.b4a.objects.collections.Map _google_userinfo = null;
String _email_normalized = "";
anywheresoftware.b4a.objects.collections.Map _preferences = null;
anywheresoftware.b4a.objects.collections.Map _onboarding = null;
String _extension = "";
String _app = "";
String _friends = "";
String _mac = "";
double _modified = 0;
String _image_url = "";
anywheresoftware.b4a.objects.collections.List _accounts = null;
anywheresoftware.b4a.objects.collections.List _subscriptions = null;
anywheresoftware.b4a.objects.collections.List _channels = null;
anywheresoftware.b4a.objects.collections.List _grants = null;
anywheresoftware.b4a.objects.collections.List _devices = null;
anywheresoftware.b4a.objects.collections.Map _coldevices = null;
String _manufacturer = "";
String _model = "";
String _nickname = "";
String _pushable = "";
int _app_version = 0;
String _active = "";
String _typ = "";
String _kind = "";
anywheresoftware.b4a.objects.collections.List _aliases = null;
anywheresoftware.b4a.objects.collections.List _pushes = null;
anywheresoftware.b4a.objects.collections.List _contacts = null;
anywheresoftware.b4a.objects.collections.List _clients = null;
anywheresoftware.b4a.objects.collections.Map _colcontacts = null;
String _status = "";
anywheresoftware.b4a.objects.collections.Map _colsubscriptions = null;
anywheresoftware.b4a.objects.collections.Map _channel = null;
String _description = "";
String _website_url = "";
String _tag = "";
 //BA.debugLineNum = 99;BA.debugLine="Sub JobDone (job As HttpJob)";
 //BA.debugLineNum = 100;BA.debugLine="LogColor(\"JobDone (\"&job.JobName&\")\",Colors.Blue)";
anywheresoftware.b4a.keywords.Common.LogColor("JobDone ("+_job._jobname+")",anywheresoftware.b4a.keywords.Common.Colors.Blue);
 //BA.debugLineNum = 101;BA.debugLine="If job.Success = True Then";
if (_job._success==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 102;BA.debugLine="Select job.JobName";
switch (BA.switchObjectToInt(_job._jobname,"ME","Devices","Contacts","Subscriptions","Pushes")) {
case 0:
 //BA.debugLineNum = 104;BA.debugLine="lv.Clear";
mostCurrent._lv.Clear();
 //BA.debugLineNum = 105;BA.debugLine="Log(job.GetString)";
anywheresoftware.b4a.keywords.Common.Log(_job._getstring());
 //BA.debugLineNum = 106;BA.debugLine="Dim parser As JSONParser";
_parser = new anywheresoftware.b4a.objects.collections.JSONParser();
 //BA.debugLineNum = 107;BA.debugLine="parser.Initialize(job.GetString)";
_parser.Initialize(_job._getstring());
 //BA.debugLineNum = 108;BA.debugLine="Dim root As Map = parser.NextObject";
_root = new anywheresoftware.b4a.objects.collections.Map();
_root = _parser.NextObject();
 //BA.debugLineNum = 109;BA.debugLine="Dim iden As String = root.Get(\"iden\")";
_iden = BA.ObjectToString(_root.Get((Object)("iden")));
 //BA.debugLineNum = 110;BA.debugLine="lv.AddTwoLines2(iden,\"iden\",root)";
mostCurrent._lv.AddTwoLines2(_iden,"iden",(Object)(_root.getObject()));
 //BA.debugLineNum = 112;BA.debugLine="Dim email As String = root.Get(\"email\")";
_email = BA.ObjectToString(_root.Get((Object)("email")));
 //BA.debugLineNum = 113;BA.debugLine="lv.AddTwoLines2(email,\"eMail\",root)";
mostCurrent._lv.AddTwoLines2(_email,"eMail",(Object)(_root.getObject()));
 //BA.debugLineNum = 115;BA.debugLine="Dim name As String = root.Get(\"name\")";
_name = BA.ObjectToString(_root.Get((Object)("name")));
 //BA.debugLineNum = 116;BA.debugLine="lv.AddTwoLines2(name,\"Name\",root)";
mostCurrent._lv.AddTwoLines2(_name,"Name",(Object)(_root.getObject()));
 //BA.debugLineNum = 118;BA.debugLine="Dim created As Double = root.Get(\"created\")";
_created = (double)(BA.ObjectToNumber(_root.Get((Object)("created"))));
 //BA.debugLineNum = 119;BA.debugLine="lv.AddTwoLines2(created,\"Created\",root)";
mostCurrent._lv.AddTwoLines2(BA.NumberToString(_created),"Created",(Object)(_root.getObject()));
 //BA.debugLineNum = 121;BA.debugLine="Dim google_userinfo As Map = root.Get(\"google_u";
_google_userinfo = new anywheresoftware.b4a.objects.collections.Map();
_google_userinfo.setObject((anywheresoftware.b4a.objects.collections.Map.MyMap)(_root.Get((Object)("google_userinfo"))));
 //BA.debugLineNum = 122;BA.debugLine="Dim name As String = google_userinfo.Get(\"name\"";
_name = BA.ObjectToString(_google_userinfo.Get((Object)("name")));
 //BA.debugLineNum = 123;BA.debugLine="Dim email_normalized As String = root.Get(\"emai";
_email_normalized = BA.ObjectToString(_root.Get((Object)("email_normalized")));
 //BA.debugLineNum = 125;BA.debugLine="Dim preferences As Map = root.Get(\"preferences\"";
_preferences = new anywheresoftware.b4a.objects.collections.Map();
_preferences.setObject((anywheresoftware.b4a.objects.collections.Map.MyMap)(_root.Get((Object)("preferences"))));
 //BA.debugLineNum = 127;BA.debugLine="Dim onboarding As Map = preferences.Get(\"onboar";
_onboarding = new anywheresoftware.b4a.objects.collections.Map();
_onboarding.setObject((anywheresoftware.b4a.objects.collections.Map.MyMap)(_preferences.Get((Object)("onboarding"))));
 //BA.debugLineNum = 128;BA.debugLine="Dim extension As String = onboarding.Get(\"exten";
_extension = BA.ObjectToString(_onboarding.Get((Object)("extension")));
 //BA.debugLineNum = 129;BA.debugLine="Dim app As String = onboarding.Get(\"app\")";
_app = BA.ObjectToString(_onboarding.Get((Object)("app")));
 //BA.debugLineNum = 130;BA.debugLine="lv.AddTwoLines2(app,\"App\",root)";
mostCurrent._lv.AddTwoLines2(_app,"App",(Object)(_root.getObject()));
 //BA.debugLineNum = 131;BA.debugLine="Dim friends As String = onboarding.Get(\"friends";
_friends = BA.ObjectToString(_onboarding.Get((Object)("friends")));
 //BA.debugLineNum = 132;BA.debugLine="lv.AddTwoLines2(friends,\"Friends\",root)";
mostCurrent._lv.AddTwoLines2(_friends,"Friends",(Object)(_root.getObject()));
 //BA.debugLineNum = 133;BA.debugLine="Dim mac As String = onboarding.Get(\"mac\")";
_mac = BA.ObjectToString(_onboarding.Get((Object)("mac")));
 //BA.debugLineNum = 134;BA.debugLine="lv.AddTwoLines2(mac,\"Mac\",root)";
mostCurrent._lv.AddTwoLines2(_mac,"Mac",(Object)(_root.getObject()));
 //BA.debugLineNum = 135;BA.debugLine="Dim modified As Double = root.Get(\"modified\")";
_modified = (double)(BA.ObjectToNumber(_root.Get((Object)("modified"))));
 //BA.debugLineNum = 136;BA.debugLine="lv.AddTwoLines2(modified,\"Modified\",root)";
mostCurrent._lv.AddTwoLines2(BA.NumberToString(_modified),"Modified",(Object)(_root.getObject()));
 //BA.debugLineNum = 137;BA.debugLine="Dim image_url As String = root.Get(\"image_url\")";
_image_url = BA.ObjectToString(_root.Get((Object)("image_url")));
 break;
case 1:
 //BA.debugLineNum = 139;BA.debugLine="lv.Clear";
mostCurrent._lv.Clear();
 //BA.debugLineNum = 140;BA.debugLine="Log(job.GetString)";
anywheresoftware.b4a.keywords.Common.Log(_job._getstring());
 //BA.debugLineNum = 141;BA.debugLine="Dim parser As JSONParser";
_parser = new anywheresoftware.b4a.objects.collections.JSONParser();
 //BA.debugLineNum = 142;BA.debugLine="parser.Initialize(job.GetString)";
_parser.Initialize(_job._getstring());
 //BA.debugLineNum = 143;BA.debugLine="Dim root As Map = parser.NextObject";
_root = new anywheresoftware.b4a.objects.collections.Map();
_root = _parser.NextObject();
 //BA.debugLineNum = 144;BA.debugLine="Dim accounts As List = root.Get(\"accounts\")";
_accounts = new anywheresoftware.b4a.objects.collections.List();
_accounts.setObject((java.util.List)(_root.Get((Object)("accounts"))));
 //BA.debugLineNum = 145;BA.debugLine="Dim subscriptions As List = root.Get(\"subscript";
_subscriptions = new anywheresoftware.b4a.objects.collections.List();
_subscriptions.setObject((java.util.List)(_root.Get((Object)("subscriptions"))));
 //BA.debugLineNum = 146;BA.debugLine="Dim channels As List = root.Get(\"channels\")";
_channels = new anywheresoftware.b4a.objects.collections.List();
_channels.setObject((java.util.List)(_root.Get((Object)("channels"))));
 //BA.debugLineNum = 147;BA.debugLine="Dim grants As List = root.Get(\"grants\")";
_grants = new anywheresoftware.b4a.objects.collections.List();
_grants.setObject((java.util.List)(_root.Get((Object)("grants"))));
 //BA.debugLineNum = 148;BA.debugLine="Dim devices As List = root.Get(\"devices\")";
_devices = new anywheresoftware.b4a.objects.collections.List();
_devices.setObject((java.util.List)(_root.Get((Object)("devices"))));
 //BA.debugLineNum = 149;BA.debugLine="For Each coldevices As Map In devices";
_coldevices = new anywheresoftware.b4a.objects.collections.Map();
final anywheresoftware.b4a.BA.IterableList group105 = _devices;
final int groupLen105 = group105.getSize();
for (int index105 = 0;index105 < groupLen105 ;index105++){
_coldevices.setObject((anywheresoftware.b4a.objects.collections.Map.MyMap)(group105.Get(index105)));
 //BA.debugLineNum = 150;BA.debugLine="Dim manufacturer As String = coldevices.Get(\"m";
_manufacturer = BA.ObjectToString(_coldevices.Get((Object)("manufacturer")));
 //BA.debugLineNum = 152;BA.debugLine="Dim model As String = coldevices.Get(\"model\")";
_model = BA.ObjectToString(_coldevices.Get((Object)("model")));
 //BA.debugLineNum = 154;BA.debugLine="Dim nickname As String = coldevices.Get(\"nickn";
_nickname = BA.ObjectToString(_coldevices.Get((Object)("nickname")));
 //BA.debugLineNum = 155;BA.debugLine="lv.AddTwoLines2(nickname,\"Nickname\",coldevices";
mostCurrent._lv.AddTwoLines2(_nickname,"Nickname",(Object)(_coldevices.getObject()));
 //BA.debugLineNum = 156;BA.debugLine="Dim created As Double = coldevices.Get(\"create";
_created = (double)(BA.ObjectToNumber(_coldevices.Get((Object)("created"))));
 //BA.debugLineNum = 158;BA.debugLine="Dim pushable As String = coldevices.Get(\"pusha";
_pushable = BA.ObjectToString(_coldevices.Get((Object)("pushable")));
 //BA.debugLineNum = 159;BA.debugLine="lv.AddTwoLines2(pushable,\"Pushable\",coldevices";
mostCurrent._lv.AddTwoLines2(_pushable,"Pushable",(Object)(_coldevices.getObject()));
 //BA.debugLineNum = 160;BA.debugLine="Dim app_version As Int = coldevices.Get(\"app_v";
_app_version = (int)(BA.ObjectToNumber(_coldevices.Get((Object)("app_version"))));
 //BA.debugLineNum = 162;BA.debugLine="Dim active As String = coldevices.Get(\"active\"";
_active = BA.ObjectToString(_coldevices.Get((Object)("active")));
 //BA.debugLineNum = 164;BA.debugLine="Dim Typ As String = coldevices.Get(\"type\")";
_typ = BA.ObjectToString(_coldevices.Get((Object)("type")));
 //BA.debugLineNum = 166;BA.debugLine="Dim iden As String = coldevices.Get(\"iden\")";
_iden = BA.ObjectToString(_coldevices.Get((Object)("iden")));
 //BA.debugLineNum = 168;BA.debugLine="Dim kind As String = coldevices.Get(\"kind\")";
_kind = BA.ObjectToString(_coldevices.Get((Object)("kind")));
 //BA.debugLineNum = 169;BA.debugLine="Dim modified As Double = coldevices.Get(\"modif";
_modified = (double)(BA.ObjectToNumber(_coldevices.Get((Object)("modified"))));
 //BA.debugLineNum = 171;BA.debugLine="lv.AddSingleLine(\"\")";
mostCurrent._lv.AddSingleLine("");
 }
;
 //BA.debugLineNum = 173;BA.debugLine="Dim aliases As List = root.Get(\"aliases\")";
_aliases = new anywheresoftware.b4a.objects.collections.List();
_aliases.setObject((java.util.List)(_root.Get((Object)("aliases"))));
 //BA.debugLineNum = 174;BA.debugLine="Dim pushes As List = root.Get(\"pushes\")";
_pushes = new anywheresoftware.b4a.objects.collections.List();
_pushes.setObject((java.util.List)(_root.Get((Object)("pushes"))));
 //BA.debugLineNum = 175;BA.debugLine="Dim contacts As List = root.Get(\"contacts\")";
_contacts = new anywheresoftware.b4a.objects.collections.List();
_contacts.setObject((java.util.List)(_root.Get((Object)("contacts"))));
 //BA.debugLineNum = 176;BA.debugLine="Dim clients As List = root.Get(\"clients\")";
_clients = new anywheresoftware.b4a.objects.collections.List();
_clients.setObject((java.util.List)(_root.Get((Object)("clients"))));
 break;
case 2:
 //BA.debugLineNum = 178;BA.debugLine="lv.Clear";
mostCurrent._lv.Clear();
 //BA.debugLineNum = 179;BA.debugLine="Log(job.GetString)";
anywheresoftware.b4a.keywords.Common.Log(_job._getstring());
 //BA.debugLineNum = 180;BA.debugLine="Dim parser As JSONParser";
_parser = new anywheresoftware.b4a.objects.collections.JSONParser();
 //BA.debugLineNum = 181;BA.debugLine="parser.Initialize(job.GetString)";
_parser.Initialize(_job._getstring());
 //BA.debugLineNum = 182;BA.debugLine="Dim root As Map = parser.NextObject";
_root = new anywheresoftware.b4a.objects.collections.Map();
_root = _parser.NextObject();
 //BA.debugLineNum = 183;BA.debugLine="Dim contacts As List = root.Get(\"contacts\")";
_contacts = new anywheresoftware.b4a.objects.collections.List();
_contacts.setObject((java.util.List)(_root.Get((Object)("contacts"))));
 //BA.debugLineNum = 184;BA.debugLine="For Each colcontacts As Map In contacts";
_colcontacts = new anywheresoftware.b4a.objects.collections.Map();
final anywheresoftware.b4a.BA.IterableList group132 = _contacts;
final int groupLen132 = group132.getSize();
for (int index132 = 0;index132 < groupLen132 ;index132++){
_colcontacts.setObject((anywheresoftware.b4a.objects.collections.Map.MyMap)(group132.Get(index132)));
 //BA.debugLineNum = 185;BA.debugLine="Dim name As String = colcontacts.Get(\"name\")";
_name = BA.ObjectToString(_colcontacts.Get((Object)("name")));
 //BA.debugLineNum = 186;BA.debugLine="Dim email As String = colcontacts.Get(\"email\")";
_email = BA.ObjectToString(_colcontacts.Get((Object)("email")));
 //BA.debugLineNum = 187;BA.debugLine="lv.AddTwoLines2(name,email,colcontacts)";
mostCurrent._lv.AddTwoLines2(_name,_email,(Object)(_colcontacts.getObject()));
 //BA.debugLineNum = 188;BA.debugLine="Dim status As String = colcontacts.Get(\"status";
_status = BA.ObjectToString(_colcontacts.Get((Object)("status")));
 //BA.debugLineNum = 189;BA.debugLine="Dim image_url As String = colcontacts.Get(\"ima";
_image_url = BA.ObjectToString(_colcontacts.Get((Object)("image_url")));
 //BA.debugLineNum = 190;BA.debugLine="Dim created As Double = colcontacts.Get(\"creat";
_created = (double)(BA.ObjectToNumber(_colcontacts.Get((Object)("created"))));
 //BA.debugLineNum = 191;BA.debugLine="Dim active As String = colcontacts.Get(\"active";
_active = BA.ObjectToString(_colcontacts.Get((Object)("active")));
 //BA.debugLineNum = 193;BA.debugLine="Dim email_normalized As String = colcontacts.G";
_email_normalized = BA.ObjectToString(_colcontacts.Get((Object)("email_normalized")));
 //BA.debugLineNum = 194;BA.debugLine="Dim iden As String = colcontacts.Get(\"iden\")";
_iden = BA.ObjectToString(_colcontacts.Get((Object)("iden")));
 //BA.debugLineNum = 195;BA.debugLine="Dim modified As Double = colcontacts.Get(\"modi";
_modified = (double)(BA.ObjectToNumber(_colcontacts.Get((Object)("modified"))));
 }
;
 break;
case 3:
 //BA.debugLineNum = 200;BA.debugLine="Log(job.GetString)";
anywheresoftware.b4a.keywords.Common.Log(_job._getstring());
 //BA.debugLineNum = 201;BA.debugLine="lv.Clear";
mostCurrent._lv.Clear();
 //BA.debugLineNum = 202;BA.debugLine="Dim parser As JSONParser";
_parser = new anywheresoftware.b4a.objects.collections.JSONParser();
 //BA.debugLineNum = 203;BA.debugLine="parser.Initialize(job.GetString)";
_parser.Initialize(_job._getstring());
 //BA.debugLineNum = 204;BA.debugLine="Dim root As Map = parser.NextObject";
_root = new anywheresoftware.b4a.objects.collections.Map();
_root = _parser.NextObject();
 //BA.debugLineNum = 207;BA.debugLine="Dim subscriptions As List = root.Get(\"subscript";
_subscriptions = new anywheresoftware.b4a.objects.collections.List();
_subscriptions.setObject((java.util.List)(_root.Get((Object)("subscriptions"))));
 //BA.debugLineNum = 208;BA.debugLine="For Each colsubscriptions As Map In subscriptio";
_colsubscriptions = new anywheresoftware.b4a.objects.collections.Map();
final anywheresoftware.b4a.BA.IterableList group151 = _subscriptions;
final int groupLen151 = group151.getSize();
for (int index151 = 0;index151 < groupLen151 ;index151++){
_colsubscriptions.setObject((anywheresoftware.b4a.objects.collections.Map.MyMap)(group151.Get(index151)));
 //BA.debugLineNum = 209;BA.debugLine="Dim active As String = colsubscriptions.Get(\"a";
_active = BA.ObjectToString(_colsubscriptions.Get((Object)("active")));
 //BA.debugLineNum = 212;BA.debugLine="Dim channel As Map = colsubscriptions.Get(\"cha";
_channel = new anywheresoftware.b4a.objects.collections.Map();
_channel.setObject((anywheresoftware.b4a.objects.collections.Map.MyMap)(_colsubscriptions.Get((Object)("channel"))));
 //BA.debugLineNum = 213;BA.debugLine="Dim name As String = channel.Get(\"name\")";
_name = BA.ObjectToString(_channel.Get((Object)("name")));
 //BA.debugLineNum = 214;BA.debugLine="lv.AddTwoLines2(name,\"Name\",channel)";
mostCurrent._lv.AddTwoLines2(_name,"Name",(Object)(_channel.getObject()));
 //BA.debugLineNum = 215;BA.debugLine="Dim description As String = channel.Get(\"descr";
_description = BA.ObjectToString(_channel.Get((Object)("description")));
 //BA.debugLineNum = 217;BA.debugLine="Dim website_url As String = channel.Get(\"websi";
_website_url = BA.ObjectToString(_channel.Get((Object)("website_url")));
 //BA.debugLineNum = 219;BA.debugLine="Dim image_url As String = channel.Get(\"image_u";
_image_url = BA.ObjectToString(_channel.Get((Object)("image_url")));
 //BA.debugLineNum = 220;BA.debugLine="Dim tag As String = channel.Get(\"tag\")";
_tag = BA.ObjectToString(_channel.Get((Object)("tag")));
 //BA.debugLineNum = 221;BA.debugLine="Dim iden As String = channel.Get(\"iden\")";
_iden = BA.ObjectToString(_channel.Get((Object)("iden")));
 //BA.debugLineNum = 225;BA.debugLine="Dim created As Double = colsubscriptions.Get(\"";
_created = (double)(BA.ObjectToNumber(_colsubscriptions.Get((Object)("created"))));
 //BA.debugLineNum = 227;BA.debugLine="Dim iden As String = colsubscriptions.Get(\"ide";
_iden = BA.ObjectToString(_colsubscriptions.Get((Object)("iden")));
 //BA.debugLineNum = 228;BA.debugLine="Dim modified As Double = colsubscriptions.Get(";
_modified = (double)(BA.ObjectToNumber(_colsubscriptions.Get((Object)("modified"))));
 //BA.debugLineNum = 229;BA.debugLine="lv.AddSingleLine(\"\")";
mostCurrent._lv.AddSingleLine("");
 }
;
 break;
case 4:
 //BA.debugLineNum = 232;BA.debugLine="Log(job.GetString)";
anywheresoftware.b4a.keywords.Common.Log(_job._getstring());
 //BA.debugLineNum = 233;BA.debugLine="lv.Clear";
mostCurrent._lv.Clear();
 break;
}
;
 }else {
 //BA.debugLineNum = 236;BA.debugLine="LogColor(\"JobDone Error: \"&job.ErrorMessage,Colo";
anywheresoftware.b4a.keywords.Common.LogColor("JobDone Error: "+_job._errormessage,anywheresoftware.b4a.keywords.Common.Colors.Red);
 };
 //BA.debugLineNum = 238;BA.debugLine="job.Release";
_job._release();
 //BA.debugLineNum = 239;BA.debugLine="End Sub";
return "";
}
public static String  _lv_itemclick(int _position,Object _value) throws Exception{
 //BA.debugLineNum = 245;BA.debugLine="Sub lv_ItemClick (Position As Int, Value As Object";
 //BA.debugLineNum = 247;BA.debugLine="End Sub";
return "";
}
public static String  _lv_itemlongclick(int _position,Object _value) throws Exception{
 //BA.debugLineNum = 248;BA.debugLine="Sub lv_ItemLongClick (Position As Int, Value As Ob";
 //BA.debugLineNum = 249;BA.debugLine="aktdest = Value";
_aktdest.setObject((anywheresoftware.b4a.objects.collections.Map.MyMap)(_value));
 //BA.debugLineNum = 250;BA.debugLine="StartActivity(push)";
anywheresoftware.b4a.keywords.Common.StartActivity(mostCurrent.activityBA,(Object)(mostCurrent._push.getObject()));
 //BA.debugLineNum = 251;BA.debugLine="End Sub";
return "";
}
public static String  _mnucontacts_click() throws Exception{
anywheresoftware.b4a.samples.httputils2.httpjob _job = null;
 //BA.debugLineNum = 56;BA.debugLine="Sub mnuContacts_Click";
 //BA.debugLineNum = 57;BA.debugLine="Dim job As HttpJob";
_job = new anywheresoftware.b4a.samples.httputils2.httpjob();
 //BA.debugLineNum = 58;BA.debugLine="job.Initialize(\"Contacts\",Me)";
_job._initialize(processBA,"Contacts",main.getObject());
 //BA.debugLineNum = 59;BA.debugLine="job.Download(PBcontacts)";
_job._download(_pbcontacts);
 //BA.debugLineNum = 60;BA.debugLine="job.GetRequest.SetHeader(\"Authorization\", \"Bearer";
_job._getrequest().SetHeader("Authorization","Bearer "+_secret);
 //BA.debugLineNum = 61;BA.debugLine="End Sub";
return "";
}
public static String  _mnudevices_click() throws Exception{
anywheresoftware.b4a.samples.httputils2.httpjob _job = null;
 //BA.debugLineNum = 62;BA.debugLine="Sub mnuDevices_Click";
 //BA.debugLineNum = 63;BA.debugLine="Dim job As HttpJob";
_job = new anywheresoftware.b4a.samples.httputils2.httpjob();
 //BA.debugLineNum = 64;BA.debugLine="job.Initialize(\"Devices\",Me)";
_job._initialize(processBA,"Devices",main.getObject());
 //BA.debugLineNum = 65;BA.debugLine="job.Download(PBdevices)";
_job._download(_pbdevices);
 //BA.debugLineNum = 66;BA.debugLine="job.GetRequest.SetHeader(\"Authorization\", \"Bearer";
_job._getrequest().SetHeader("Authorization","Bearer "+_secret);
 //BA.debugLineNum = 67;BA.debugLine="End Sub";
return "";
}
public static String  _mnume_click() throws Exception{
anywheresoftware.b4a.samples.httputils2.httpjob _job = null;
 //BA.debugLineNum = 50;BA.debugLine="Sub mnuMe_Click";
 //BA.debugLineNum = 51;BA.debugLine="Dim job As HttpJob";
_job = new anywheresoftware.b4a.samples.httputils2.httpjob();
 //BA.debugLineNum = 52;BA.debugLine="job.Initialize(\"ME\",Me)";
_job._initialize(processBA,"ME",main.getObject());
 //BA.debugLineNum = 53;BA.debugLine="job.Download(PBme)";
_job._download(_pbme);
 //BA.debugLineNum = 54;BA.debugLine="job.GetRequest.SetHeader(\"Authorization\", \"Bearer";
_job._getrequest().SetHeader("Authorization","Bearer "+_secret);
 //BA.debugLineNum = 55;BA.debugLine="End Sub";
return "";
}
public static String  _mnupushes_click() throws Exception{
anywheresoftware.b4a.samples.httputils2.httpjob _job = null;
 //BA.debugLineNum = 74;BA.debugLine="Sub mnuPushes_Click";
 //BA.debugLineNum = 75;BA.debugLine="Dim job As HttpJob";
_job = new anywheresoftware.b4a.samples.httputils2.httpjob();
 //BA.debugLineNum = 76;BA.debugLine="job.Initialize(\"Pushes\",Me)";
_job._initialize(processBA,"Pushes",main.getObject());
 //BA.debugLineNum = 77;BA.debugLine="job.Download(PBpushes)";
_job._download(_pbpushes);
 //BA.debugLineNum = 78;BA.debugLine="job.GetRequest.SetHeader(\"Authorization\", \"Bearer";
_job._getrequest().SetHeader("Authorization","Bearer "+_secret);
 //BA.debugLineNum = 79;BA.debugLine="End Sub";
return "";
}
public static String  _mnusubscriptions_click() throws Exception{
anywheresoftware.b4a.samples.httputils2.httpjob _job = null;
 //BA.debugLineNum = 68;BA.debugLine="Sub mnuSubscriptions_Click";
 //BA.debugLineNum = 69;BA.debugLine="Dim job As HttpJob";
_job = new anywheresoftware.b4a.samples.httputils2.httpjob();
 //BA.debugLineNum = 70;BA.debugLine="job.Initialize(\"Subscriptions\",Me)";
_job._initialize(processBA,"Subscriptions",main.getObject());
 //BA.debugLineNum = 71;BA.debugLine="job.Download(PBsubscriptions)";
_job._download(_pbsubscriptions);
 //BA.debugLineNum = 72;BA.debugLine="job.GetRequest.SetHeader(\"Authorization\", \"Bearer";
_job._getrequest().SetHeader("Authorization","Bearer "+_secret);
 //BA.debugLineNum = 73;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 16;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="Dim aktdest As Map";
_aktdest = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 20;BA.debugLine="Dim secret As String = \"oK9RkUjvaelVZzUa345vpSyHz";
_secret = "oK9RkUjvaelVZzUa345vpSyHzGONmX1Q";
 //BA.debugLineNum = 21;BA.debugLine="Dim Const PB As String = \"https://api.pushbullet.";
_pb = "https://api.pushbullet.com/v2/";
 //BA.debugLineNum = 24;BA.debugLine="Dim Const PBme As String = PB&\"users/me\"";
_pbme = _pb+"users/me";
 //BA.debugLineNum = 27;BA.debugLine="Dim Const PBdevices As String = PB&\"devices\"";
_pbdevices = _pb+"devices";
 //BA.debugLineNum = 30;BA.debugLine="Dim Const PBcontacts As String = PB&\"contacts\"";
_pbcontacts = _pb+"contacts";
 //BA.debugLineNum = 33;BA.debugLine="Dim Const PBsubscriptions As String = PB&\"subscri";
_pbsubscriptions = _pb+"subscriptions";
 //BA.debugLineNum = 36;BA.debugLine="Dim Const PBpushes As String = PB&\"pushes\"";
_pbpushes = _pb+"pushes";
 //BA.debugLineNum = 39;BA.debugLine="Dim Const PBupload As String = PB&\"upload-request";
_pbupload = _pb+"upload-request";
 //BA.debugLineNum = 42;BA.debugLine="Dim Const PBoauth2 As String = PB&\"oauth2\"";
_pboauth2 = _pb+"oauth2";
 //BA.debugLineNum = 43;BA.debugLine="End Sub";
return "";
}
}
